local entity_id = GetUpdatedEntityID()
local total_accumulated_gold = 0

for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do

	if EntityGetName(child) == "gold_sucker" then

		local component_sucker = EntityGetFirstComponent(child, "MaterialSuckerComponent")
		local compovar_accumulated = EntityGetFirstComponent(child, "VariableStorageComponent")

		if (component_sucker ~= nil and compovar_accumulated ~= nil) then
			local accumulated_currently = ComponentGetValue2(component_sucker, "mGoldAccumulator")
			local accumulated_last_frame = ComponentGetValue2(compovar_accumulated, "value_int")

			if (accumulated_currently ~= accumulated_last_frame) then
				if (accumulated_currently > accumulated_last_frame) then
					total_accumulated_gold = total_accumulated_gold + (accumulated_currently - accumulated_last_frame)
				end
		
				ComponentSetValue(compovar_accumulated, "value_int", accumulated_currently)
			end
		end
	end
end

if (total_accumulated_gold > 0) then
	local wallet = EntityGetFirstComponent(entity_id, "WalletComponent")
	ComponentSetValue2(wallet, "money", ComponentGetValue2(wallet, "money") + total_accumulated_gold)
end