dofile_once("data/scripts/lib/utilities.lua")

function damage_received( dmg, msg, source, is_fatal)

	local entity_id = GetUpdatedEntityID()
	local parent_id = EntityGetParent( entity_id )
	local x,y = EntityGetTransform( parent_id )
	
	local damage_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
	local damage_component_parent = EntityGetFirstComponentIncludingDisabled(parent_id, "DamageModelComponent")
	
	if ( damage_component ~= nil ) and ( damage_component > 0 ) then
		for k, v in pairs(ComponentGetMembers( damage_component_parent )) do
			if ( k ~= "damage_multipliers" ) and
			( k ~= "materials_damage" ) and
			( k ~= "ui_report_damage" ) and
			( k ~= "ui_force_report_damage" ) and
			( k ~= "air_needed" ) and
			( k ~= "falling_damages" ) and
			( k ~= "fire_probability_of_ignition" ) and
			( k ~= "is_on_fire" ) and
			( k ~= "physics_objects_damage" ) and
			( k ~= "create_ragdoll" ) and
			( k ~= "ragdoll_filenames_file" ) and
			( k ~= "ragdollify_child_entity_sprites" ) and
			( k ~= "blood_spray_material" ) and
			( k ~= "critical_damage_resistance" ) and
			( k ~= "mCollisionMessageMaterials" ) and
			( k ~= "mDamageMaterialsHowMuch" ) and
			( k ~= "mCollisionMessageMaterialCountsThisFrame" ) and
			( k ~= "mDamageMaterials" ) and
			( k ~= "mMaterialDamageThisFrame" ) and
			( k ~= "mPhysicsDamageVecThisFrame" ) then
				ComponentSetValue2( damage_component, k, ComponentGetValue2(damage_component_parent, k) )
			end
		end
	end
	
	-- Sync material damage from parent entity to current entity
	
	function split_string(inputstr, sep)
	  sep = sep or "%s"
	  local t= {}
	  for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
		table.insert(t, str)
	  end
	  return t
	end

	local material_table = split_string(ComponentGetValue2(damage_component_parent, "materials_that_damage"), ",")
	local material_damage_table = split_string(ComponentGetValue2(damage_component_parent, "materials_how_much_damage"), ",")

	if material_table and material_damage_table then
		for index, material in ipairs(material_table) do
			local damage = material_damage_table[index]
			EntitySetDamageFromMaterial(entity_id, material, damage)
		end
	end

	EntityInflictDamage( parent_id, dmg, "DAMAGE_MATERIAL", msg, "NONE", 0, 0, entity_id, x, y )
end