dofile("data/scripts/lib/mod_settings.lua")

function mod_setting_change_callback( mod_id, gui, in_main_menu, setting, old_value, new_value  )
	print( tostring(new_value) )
end

local mod_id = "inverse_gravity"
mod_settings_version = 1
mod_settings = 
{
	{
		id = "physics_gravity",
		ui_name = "Physics Gravity",
		ui_description = "Toggle physics material gravity inversion",
		value_default = "inverted",
		values = {
			{"inverted", "Inverted"},
			{"zero", "Zero"},
			{"normal", "Normal"}
		},
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
	{
		id = "sand_gravity",
		ui_name = "Sand Gravity",
		ui_description = "Toggle Sand material gravity inversion",
		value_default = true,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
	{
		id = "liquid_gravity",
		ui_name = "Liquid Gravity",
		ui_description = "Toggle Liquid material gravity inversion",
		value_default = true,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
	{
		id = "gas_gravity",
		ui_name = "Gas Gravity",
		ui_description = "Toggle Gas material gravity inversion",
		value_default = true,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
	{
		id = "fire_gravity",
		ui_name = "Fire Particle Gravity",
		ui_description = "Toggle Fire material gravity inversion",
		value_default = true,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
	{
		id = "projectile_gravity",
		ui_name = "Projectile Gravity",
		ui_description = "Toggle projectile gravity inversion",
		value_default = true,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
	{
		id = "item_gravity",
		ui_name = "Item Gravity",
		ui_description = "Toggle item gravity inversion",
		value_default = true,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
	{
		id = "player",
		ui_name = "Flip the player",
		ui_description = "Toggle flipping the player",
		value_default = true,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
	{
		id = "flip_screen",
		ui_name = "Flip the Screen",
		ui_description = "Toggle screen flipping",
		value_default = true,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
}

function ModSettingsUpdate( init_scope )
	local old_version = mod_settings_get_version( mod_id )
	mod_settings_update( mod_id, mod_settings, init_scope )
end

function ModSettingsGuiCount()
	return mod_settings_gui_count( mod_id, mod_settings )
end

function ModSettingsGui( gui, in_main_menu )
	mod_settings_gui( mod_id, mod_settings, gui, in_main_menu )
end